// $Id: heartbeat.js,v 1.2 2008/02/12 00:04:09 redbox2000drupalorg Exp $
/*
 * JHeartbeat 0.1.2 Custom
 * By Jason Levine (http://www.jasons-toolbox.com)
 * A heartbeat plugin for the jquery library to help keep sessions alive.
 *
 * This plugin is copied from the plugin made by Jason Levine but it allows 
 * you to specify the div id where the heatbeat will update.
 */
/* [ ML -- 26AUG2007 ] 
 *    As part of the Drupal wrapper module project 'jquery_heartbeat', I changed 
 *    the default 'heartbeat' page reference to 'heartbeat.php', and the default
 *    <div> tag ID name to 'heartbeat'
 *
 *    NOTE: this file is also available in 'compressed' form.
 */
 
$.jheartbeat = {

  options: {
    url: "heartbeat.php",
    delay: 1500,
    div_id: "heartbeat"
  },
  
  beatfunction:  function(){
    ; // Insert optional magic here!!
  },
  
  timeoutobj: {
    id: -1
  },
  
  set: function(options, onbeatfunction) {
    if (this.timeoutobj.id > -1) {
      clearTimeout(this.timeoutobj);
    }
    if (options) {
      $.extend(this.options, options);
    }
    if (onbeatfunction) {
      this.beatfunction = onbeatfunction;
    }
    
    // Add the HeartBeatDIV to the page
    $("body").append("<div id=\"" + this.options.div_id + "\" style=\"display: none;\"></div>");
    this.timeoutobj.id = setTimeout("$.jheartbeat.beat();", this.options.delay);
  },
  
  beat: function() {
    $("#" + this.options.div_id).load(this.options.url);
    this.timeoutobj.id = setTimeout("$.jheartbeat.beat();", this.options.delay);
    this.beatfunction();
  }
};
